// cpp(meta datanetwork format) source file JavaModel.cpp generated from diagram JavaModel
// generated on Fri Dec 02 10:50:59 2005

#include "JavaModel.h"
#include "UmlExt.h"

#include "UdmStatic.h"

// cross-package metainformation header file
#include "MI2SI.h"

namespace JavaModel {

	::Uml::Diagram umldiagram;

		::Uml::Class RootFolder::meta;
		::Uml::Class Method::meta;
		::Uml::Class JFeature::meta;
		::Uml::Class Field::meta;
		::Uml::Class JClass::meta;
		::Uml::Class Java::meta;
		::Uml::Class JClassHasJFeature::meta;
		::Uml::Class JInheritance::meta;
		::Uml::Class JAgregation::meta;
		::Uml::Class MgaObject::meta;
		::Uml::Attribute RootFolder::meta_name;
		::Uml::Attribute MgaObject::meta_name;
		::Uml::Attribute MgaObject::meta_position;
		::Uml::AssociationRole JFeature::meta_srcJClassHasJFeature, JFeature::meta_srcJClassHasJFeature_rev;
		::Uml::AssociationRole JClass::meta_dstJClassHasJFeature, JClass::meta_dstJClassHasJFeature_rev;
		::Uml::AssociationRole JClass::meta_dstJInheritance, JClass::meta_dstJInheritance_rev;
		::Uml::AssociationRole JClass::meta_dstJAgregation, JClass::meta_dstJAgregation_rev;
		::Uml::AssociationRole JClass::meta_srcJInheritance, JClass::meta_srcJInheritance_rev;
		::Uml::AssociationRole JClass::meta_srcJAgregation, JClass::meta_srcJAgregation_rev;
		::Uml::AssociationRole JClass::meta_src;
		::Uml::AssociationRole JClassHasJFeature::meta_srcJClassHasJFeature_end_;
		::Uml::AssociationRole JClassHasJFeature::meta_dstJClassHasJFeature_end_;
		::Uml::AssociationRole JInheritance::meta_srcJInheritance_end_;
		::Uml::AssociationRole JInheritance::meta_dstJInheritance_end_;
		::Uml::AssociationRole JAgregation::meta_srcJAgregation_end_;
		::Uml::AssociationRole JAgregation::meta_dstJAgregation_end_;
		::Uml::CompositionParentRole RootFolder::meta_RootFolder_parent;
		::Uml::CompositionParentRole JFeature::meta_Java_parent;
		::Uml::CompositionParentRole JClass::meta_Java_parent;
		::Uml::CompositionParentRole Java::meta_RootFolder_parent;
		::Uml::CompositionParentRole JClassHasJFeature::meta_Java_parent;
		::Uml::CompositionParentRole JInheritance::meta_Java_parent;
		::Uml::CompositionParentRole JAgregation::meta_Java_parent;
		::Uml::CompositionChildRole RootFolder::meta_Java_children;
		::Uml::CompositionChildRole RootFolder::meta_RootFolder_children;
		::Uml::CompositionChildRole Java::meta_JClassHasJFeature_children;
		::Uml::CompositionChildRole Java::meta_JFeature_children;
		::Uml::CompositionChildRole Java::meta_JAgregation_children;
		::Uml::CompositionChildRole Java::meta_JInheritance_children;
		::Uml::CompositionChildRole Java::meta_JClass_children;
		void Creates()
		{
			RootFolder::meta = ::Uml::Class::Create(umldiagram);
			Method::meta = ::Uml::Class::Create(umldiagram);
			JFeature::meta = ::Uml::Class::Create(umldiagram);
			Field::meta = ::Uml::Class::Create(umldiagram);
			JClass::meta = ::Uml::Class::Create(umldiagram);
			Java::meta = ::Uml::Class::Create(umldiagram);
			JClassHasJFeature::meta = ::Uml::Class::Create(umldiagram);
			JInheritance::meta = ::Uml::Class::Create(umldiagram);
			JAgregation::meta = ::Uml::Class::Create(umldiagram);
			MgaObject::meta = ::Uml::Class::Create(umldiagram);
			RootFolder::meta_name = ::Uml::Attribute::Create(RootFolder::meta);
			MgaObject::meta_name = ::Uml::Attribute::Create(MgaObject::meta);
			MgaObject::meta_position = ::Uml::Attribute::Create(MgaObject::meta);
		}
		void InitClassesAttributes()
		{
			RootFolder::meta.name() = "RootFolder";
			RootFolder::meta.isAbstract() = false;
			RootFolder::meta.stereotype() = "Folder";
			Method::meta.name() = "Method";
			Method::meta.isAbstract() = false;
			Method::meta.stereotype() = "Atom";
			JFeature::meta.name() = "JFeature";
			JFeature::meta.isAbstract() = false;
			JFeature::meta.stereotype() = "Atom";
			Field::meta.name() = "Field";
			Field::meta.isAbstract() = false;
			Field::meta.stereotype() = "Atom";
			JClass::meta.name() = "JClass";
			JClass::meta.isAbstract() = false;
			JClass::meta.stereotype() = "Atom";
			Java::meta.name() = "Java";
			Java::meta.isAbstract() = false;
			Java::meta.stereotype() = "Model";
			JClassHasJFeature::meta.name() = "JClassHasJFeature";
			JClassHasJFeature::meta.isAbstract() = false;
			JClassHasJFeature::meta.stereotype() = "Connection";
			JInheritance::meta.name() = "JInheritance";
			JInheritance::meta.isAbstract() = false;
			JInheritance::meta.stereotype() = "Connection";
			JAgregation::meta.name() = "JAgregation";
			JAgregation::meta.isAbstract() = false;
			JAgregation::meta.stereotype() = "Connection";
			MgaObject::meta.name() = "MgaObject";
			MgaObject::meta.isAbstract() = true;
			
			RootFolder::meta_name.name() = "name";
			RootFolder::meta_name.type() = "String";
			RootFolder::meta_name.min() = 0;
			RootFolder::meta_name.max() = 1;
			RootFolder::meta_name.nonpersistent() = false;
			RootFolder::meta_name.registry() = false;
			RootFolder::meta_name.ordered() = false;
			RootFolder::meta_name.visibility() = "public";
			RootFolder::meta_name.defvalue() = vector<string>();
			MgaObject::meta_name.name() = "name";
			MgaObject::meta_name.type() = "String";
			MgaObject::meta_name.min() = 0;
			MgaObject::meta_name.max() = 1;
			MgaObject::meta_name.nonpersistent() = false;
			MgaObject::meta_name.registry() = false;
			MgaObject::meta_name.ordered() = false;
			MgaObject::meta_name.visibility() = "public";
			MgaObject::meta_name.defvalue() = vector<string>();
			MgaObject::meta_position.name() = "position";
			MgaObject::meta_position.type() = "String";
			MgaObject::meta_position.min() = 0;
			MgaObject::meta_position.max() = 1;
			MgaObject::meta_position.nonpersistent() = false;
			MgaObject::meta_position.registry() = false;
			MgaObject::meta_position.ordered() = false;
			MgaObject::meta_position.visibility() = "public";
			MgaObject::meta_position.defvalue() = vector<string>();
			
		}
		void InitAssociation0()
		{
			::Uml::Association ass = ::Uml::Association::Create(umldiagram);
			ass.name() = "JClassHasJFeature";
			ass.assocClass() = ::JavaModel::JClassHasJFeature::meta;
			::JavaModel::JClass::meta_dstJClassHasJFeature = ::Uml::AssociationRole::Create(ass);
			::JavaModel::JClass::meta_dstJClassHasJFeature.name() = "dstJClassHasJFeature";
			::JavaModel::JClass::meta_dstJClassHasJFeature.min() = 0;
			::JavaModel::JClass::meta_dstJClassHasJFeature.max() = -1;
			::JavaModel::JClass::meta_dstJClassHasJFeature.isNavigable() = true;
			::JavaModel::JClass::meta_dstJClassHasJFeature.isPrimary() = false;
			::JavaModel::JClass::meta_dstJClassHasJFeature.target() = ::JavaModel::JFeature::meta;
			::JavaModel::JClassHasJFeature::meta_dstJClassHasJFeature_end_ = ::JavaModel::JFeature::meta_srcJClassHasJFeature_rev = ::JavaModel::JClass::meta_dstJClassHasJFeature;
			::JavaModel::JFeature::meta_srcJClassHasJFeature = ::Uml::AssociationRole::Create(ass);
			::JavaModel::JFeature::meta_srcJClassHasJFeature.name() = "srcJClassHasJFeature";
			::JavaModel::JFeature::meta_srcJClassHasJFeature.min() = 0;
			::JavaModel::JFeature::meta_srcJClassHasJFeature.max() = -1;
			::JavaModel::JFeature::meta_srcJClassHasJFeature.isNavigable() = true;
			::JavaModel::JFeature::meta_srcJClassHasJFeature.isPrimary() = false;
			::JavaModel::JFeature::meta_srcJClassHasJFeature.target() = ::JavaModel::JClass::meta;
			::JavaModel::JClassHasJFeature::meta_srcJClassHasJFeature_end_ = ::JavaModel::JClass::meta_dstJClassHasJFeature_rev = ::JavaModel::JFeature::meta_srcJClassHasJFeature;
		};
		void InitAssociation1()
		{
			::Uml::Association ass = ::Uml::Association::Create(umldiagram);
			ass.name() = "JInheritance";
			ass.assocClass() = ::JavaModel::JInheritance::meta;
			::JavaModel::JClass::meta_dstJInheritance = ::Uml::AssociationRole::Create(ass);
			::JavaModel::JClass::meta_dstJInheritance.name() = "dstJInheritance";
			::JavaModel::JClass::meta_dstJInheritance.min() = 0;
			::JavaModel::JClass::meta_dstJInheritance.max() = -1;
			::JavaModel::JClass::meta_dstJInheritance.isNavigable() = true;
			::JavaModel::JClass::meta_dstJInheritance.isPrimary() = false;
			::JavaModel::JClass::meta_dstJInheritance.target() = ::JavaModel::JClass::meta;
			::JavaModel::JInheritance::meta_dstJInheritance_end_ = ::JavaModel::JClass::meta_srcJInheritance_rev = ::JavaModel::JClass::meta_dstJInheritance;
			::JavaModel::JClass::meta_srcJInheritance = ::Uml::AssociationRole::Create(ass);
			::JavaModel::JClass::meta_srcJInheritance.name() = "srcJInheritance";
			::JavaModel::JClass::meta_srcJInheritance.min() = 1;
			::JavaModel::JClass::meta_srcJInheritance.max() = 1;
			::JavaModel::JClass::meta_srcJInheritance.isNavigable() = true;
			::JavaModel::JClass::meta_srcJInheritance.isPrimary() = false;
			::JavaModel::JClass::meta_srcJInheritance.target() = ::JavaModel::JClass::meta;
			::JavaModel::JInheritance::meta_srcJInheritance_end_ = ::JavaModel::JClass::meta_dstJInheritance_rev = ::JavaModel::JClass::meta_srcJInheritance;
		};
		void InitAssociation2()
		{
			::Uml::Association ass = ::Uml::Association::Create(umldiagram);
			ass.name() = "JAgregation";
			ass.assocClass() = ::JavaModel::JAgregation::meta;
			::JavaModel::JClass::meta_dstJAgregation = ::Uml::AssociationRole::Create(ass);
			::JavaModel::JClass::meta_dstJAgregation.name() = "dstJAgregation";
			::JavaModel::JClass::meta_dstJAgregation.min() = 0;
			::JavaModel::JClass::meta_dstJAgregation.max() = -1;
			::JavaModel::JClass::meta_dstJAgregation.isNavigable() = true;
			::JavaModel::JClass::meta_dstJAgregation.isPrimary() = false;
			::JavaModel::JClass::meta_dstJAgregation.target() = ::JavaModel::JClass::meta;
			::JavaModel::JAgregation::meta_dstJAgregation_end_ = ::JavaModel::JClass::meta_srcJAgregation_rev = ::JavaModel::JClass::meta_dstJAgregation;
			::JavaModel::JClass::meta_srcJAgregation = ::Uml::AssociationRole::Create(ass);
			::JavaModel::JClass::meta_srcJAgregation.name() = "srcJAgregation";
			::JavaModel::JClass::meta_srcJAgregation.min() = 0;
			::JavaModel::JClass::meta_srcJAgregation.max() = -1;
			::JavaModel::JClass::meta_srcJAgregation.isNavigable() = true;
			::JavaModel::JClass::meta_srcJAgregation.isPrimary() = false;
			::JavaModel::JClass::meta_srcJAgregation.target() = ::JavaModel::JClass::meta;
			::JavaModel::JAgregation::meta_srcJAgregation_end_ = ::JavaModel::JClass::meta_dstJAgregation_rev = ::JavaModel::JClass::meta_srcJAgregation;
		};
		void InitComposition0()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::JavaModel::Java::meta_RootFolder_parent = ::Uml::CompositionParentRole::Create(comp);
			::JavaModel::Java::meta_RootFolder_parent.name() = "RootFolder_parent";
			::JavaModel::Java::meta_RootFolder_parent.isNavigable() = true;
			::JavaModel::Java::meta_RootFolder_parent.target() = ::JavaModel::RootFolder::meta;
			::JavaModel::RootFolder::meta_Java_children = ::Uml::CompositionChildRole::Create(comp);
			::JavaModel::RootFolder::meta_Java_children.name() = "Java";
			::JavaModel::RootFolder::meta_Java_children.min() = 0;
			::JavaModel::RootFolder::meta_Java_children.max() = -1;
			::JavaModel::RootFolder::meta_Java_children.isNavigable() = true;
			::JavaModel::RootFolder::meta_Java_children.target() = ::JavaModel::Java::meta;
		}
		void InitComposition1()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::JavaModel::RootFolder::meta_RootFolder_parent = ::Uml::CompositionParentRole::Create(comp);
			::JavaModel::RootFolder::meta_RootFolder_parent.name() = "RootFolder_parent";
			::JavaModel::RootFolder::meta_RootFolder_parent.isNavigable() = true;
			::JavaModel::RootFolder::meta_RootFolder_parent.target() = ::JavaModel::RootFolder::meta;
			::JavaModel::RootFolder::meta_RootFolder_children = ::Uml::CompositionChildRole::Create(comp);
			::JavaModel::RootFolder::meta_RootFolder_children.name() = "RootFolder";
			::JavaModel::RootFolder::meta_RootFolder_children.min() = 0;
			::JavaModel::RootFolder::meta_RootFolder_children.max() = -1;
			::JavaModel::RootFolder::meta_RootFolder_children.isNavigable() = true;
			::JavaModel::RootFolder::meta_RootFolder_children.target() = ::JavaModel::RootFolder::meta;
		}
		void InitComposition2()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::JavaModel::JClassHasJFeature::meta_Java_parent = ::Uml::CompositionParentRole::Create(comp);
			::JavaModel::JClassHasJFeature::meta_Java_parent.name() = "Java_parent";
			::JavaModel::JClassHasJFeature::meta_Java_parent.isNavigable() = true;
			::JavaModel::JClassHasJFeature::meta_Java_parent.target() = ::JavaModel::Java::meta;
			::JavaModel::Java::meta_JClassHasJFeature_children = ::Uml::CompositionChildRole::Create(comp);
			::JavaModel::Java::meta_JClassHasJFeature_children.name() = "JClassHasJFeature";
			::JavaModel::Java::meta_JClassHasJFeature_children.min() = 0;
			::JavaModel::Java::meta_JClassHasJFeature_children.max() = -1;
			::JavaModel::Java::meta_JClassHasJFeature_children.isNavigable() = true;
			::JavaModel::Java::meta_JClassHasJFeature_children.target() = ::JavaModel::JClassHasJFeature::meta;
		}
		void InitComposition3()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::JavaModel::JFeature::meta_Java_parent = ::Uml::CompositionParentRole::Create(comp);
			::JavaModel::JFeature::meta_Java_parent.name() = "Java_parent";
			::JavaModel::JFeature::meta_Java_parent.isNavigable() = true;
			::JavaModel::JFeature::meta_Java_parent.target() = ::JavaModel::Java::meta;
			::JavaModel::Java::meta_JFeature_children = ::Uml::CompositionChildRole::Create(comp);
			::JavaModel::Java::meta_JFeature_children.name() = "JFeature";
			::JavaModel::Java::meta_JFeature_children.min() = 0;
			::JavaModel::Java::meta_JFeature_children.max() = -1;
			::JavaModel::Java::meta_JFeature_children.isNavigable() = true;
			::JavaModel::Java::meta_JFeature_children.target() = ::JavaModel::JFeature::meta;
		}
		void InitComposition4()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::JavaModel::JAgregation::meta_Java_parent = ::Uml::CompositionParentRole::Create(comp);
			::JavaModel::JAgregation::meta_Java_parent.name() = "Java_parent";
			::JavaModel::JAgregation::meta_Java_parent.isNavigable() = true;
			::JavaModel::JAgregation::meta_Java_parent.target() = ::JavaModel::Java::meta;
			::JavaModel::Java::meta_JAgregation_children = ::Uml::CompositionChildRole::Create(comp);
			::JavaModel::Java::meta_JAgregation_children.name() = "JAgregation";
			::JavaModel::Java::meta_JAgregation_children.min() = 0;
			::JavaModel::Java::meta_JAgregation_children.max() = -1;
			::JavaModel::Java::meta_JAgregation_children.isNavigable() = true;
			::JavaModel::Java::meta_JAgregation_children.target() = ::JavaModel::JAgregation::meta;
		}
		void InitComposition5()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::JavaModel::JInheritance::meta_Java_parent = ::Uml::CompositionParentRole::Create(comp);
			::JavaModel::JInheritance::meta_Java_parent.name() = "Java_parent";
			::JavaModel::JInheritance::meta_Java_parent.isNavigable() = true;
			::JavaModel::JInheritance::meta_Java_parent.target() = ::JavaModel::Java::meta;
			::JavaModel::Java::meta_JInheritance_children = ::Uml::CompositionChildRole::Create(comp);
			::JavaModel::Java::meta_JInheritance_children.name() = "JInheritance";
			::JavaModel::Java::meta_JInheritance_children.min() = 0;
			::JavaModel::Java::meta_JInheritance_children.max() = -1;
			::JavaModel::Java::meta_JInheritance_children.isNavigable() = true;
			::JavaModel::Java::meta_JInheritance_children.target() = ::JavaModel::JInheritance::meta;
		}
		void InitComposition6()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::JavaModel::JClass::meta_Java_parent = ::Uml::CompositionParentRole::Create(comp);
			::JavaModel::JClass::meta_Java_parent.name() = "Java_parent";
			::JavaModel::JClass::meta_Java_parent.isNavigable() = true;
			::JavaModel::JClass::meta_Java_parent.target() = ::JavaModel::Java::meta;
			::JavaModel::Java::meta_JClass_children = ::Uml::CompositionChildRole::Create(comp);
			::JavaModel::Java::meta_JClass_children.name() = "JClass";
			::JavaModel::Java::meta_JClass_children.min() = 0;
			::JavaModel::Java::meta_JClass_children.max() = -1;
			::JavaModel::Java::meta_JClass_children.isNavigable() = true;
			::JavaModel::Java::meta_JClass_children.target() = ::JavaModel::JClass::meta;
		}
		void InitCrossNSCompositions()
		{
		}
		void InitInheritence()
		{
			Field::meta.subTypes() +=  ::JavaModel::Method::meta;
			Field::meta.subTypes() +=  ::JavaModel::JFeature::meta;
			MgaObject::meta.subTypes() +=  ::JavaModel::Field::meta;
			MgaObject::meta.subTypes() +=  ::JavaModel::JClass::meta;
			MgaObject::meta.subTypes() +=  ::JavaModel::Java::meta;
			MgaObject::meta.subTypes() +=  ::JavaModel::JClassHasJFeature::meta;
			MgaObject::meta.subTypes() +=  ::JavaModel::JInheritance::meta;
			MgaObject::meta.subTypes() +=  ::JavaModel::JAgregation::meta;
		}
		void InitCrossNSInheritence()
		{
		}
	 void InitializeDgr()
	{
		Creates();
		InitClassesAttributes();
			InitAssociation0();
			InitAssociation1();
			InitAssociation2();
		InitComposition0();
		InitComposition1();
		InitComposition2();
		InitComposition3();
		InitComposition4();
		InitComposition5();
		InitComposition6();
			JClass::meta_src = ::MI2SI::JClass_cross_ph_::meta_src;
		InitInheritence();
		
	}
		 void InitializeDgr(const ::Uml::Diagram & dgr)
		{
			::Uml::SetClass(RootFolder::meta, dgr, "RootFolder");
			::Uml::SetAttribute(RootFolder::meta_name,RootFolder::meta, "name");
			::Uml::SetClass(Method::meta, dgr, "Method");
			::Uml::SetClass(JFeature::meta, dgr, "JFeature");
			::Uml::SetClass(Field::meta, dgr, "Field");
			::Uml::SetClass(JClass::meta, dgr, "JClass");
			::Uml::SetClass(Java::meta, dgr, "Java");
			::Uml::SetClass(JClassHasJFeature::meta, dgr, "JClassHasJFeature");
			::Uml::SetClass(JInheritance::meta, dgr, "JInheritance");
			::Uml::SetClass(JAgregation::meta, dgr, "JAgregation");
			::Uml::SetClass(MgaObject::meta, dgr, "MgaObject");
			::Uml::SetAttribute(MgaObject::meta_name,MgaObject::meta, "name");
			::Uml::SetAttribute(MgaObject::meta_position,MgaObject::meta, "position");
			//composition child roles 
			::Uml::SetParentRole(RootFolder::meta_RootFolder_parent,RootFolder::meta,::JavaModel::RootFolder::meta, "", "");
			::Uml::SetParentRole(JFeature::meta_Java_parent,JFeature::meta,::JavaModel::Java::meta, "", "");
			::Uml::SetParentRole(JClass::meta_Java_parent,JClass::meta,::JavaModel::Java::meta, "", "");
			::Uml::SetParentRole(Java::meta_RootFolder_parent,Java::meta,::JavaModel::RootFolder::meta, "", "");
			::Uml::SetParentRole(JClassHasJFeature::meta_Java_parent,JClassHasJFeature::meta,::JavaModel::Java::meta, "", "");
			::Uml::SetParentRole(JInheritance::meta_Java_parent,JInheritance::meta,::JavaModel::Java::meta, "", "");
			::Uml::SetParentRole(JAgregation::meta_Java_parent,JAgregation::meta,::JavaModel::Java::meta, "", "");
			// composition parentroles 
			::Uml::SetChildRole(RootFolder::meta_Java_children,RootFolder::meta,::JavaModel::Java::meta, "", "");
			::Uml::SetChildRole(RootFolder::meta_RootFolder_children,RootFolder::meta,::JavaModel::RootFolder::meta, "", "");
			::Uml::SetChildRole(Java::meta_JClassHasJFeature_children,Java::meta,::JavaModel::JClassHasJFeature::meta, "", "");
			::Uml::SetChildRole(Java::meta_JFeature_children,Java::meta,::JavaModel::JFeature::meta, "", "");
			::Uml::SetChildRole(Java::meta_JAgregation_children,Java::meta,::JavaModel::JAgregation::meta, "", "");
			::Uml::SetChildRole(Java::meta_JInheritance_children,Java::meta,::JavaModel::JInheritance::meta, "", "");
			::Uml::SetChildRole(Java::meta_JClass_children,Java::meta,::JavaModel::JClass::meta, "", "");
			// Association roles 
			::Uml::SetAssocRole(JFeature::meta_srcJClassHasJFeature,JFeature::meta,::JavaModel::JClass::meta, "dstJClassHasJFeature");
			::JavaModel::JClass::meta_dstJClassHasJFeature_rev = JFeature::meta_srcJClassHasJFeature;
			::Uml::SetAssocRole(JClass::meta_dstJClassHasJFeature,JClass::meta,::JavaModel::JFeature::meta, "srcJClassHasJFeature");
			::JavaModel::JFeature::meta_srcJClassHasJFeature_rev = JClass::meta_dstJClassHasJFeature;
			::Uml::SetAssocRole(JClass::meta_dstJInheritance,JClass::meta,::JavaModel::JClass::meta, "srcJInheritance");
			::JavaModel::JClass::meta_srcJInheritance_rev = JClass::meta_dstJInheritance;
			::Uml::SetAssocRole(JClass::meta_dstJAgregation,JClass::meta,::JavaModel::JClass::meta, "srcJAgregation");
			::JavaModel::JClass::meta_srcJAgregation_rev = JClass::meta_dstJAgregation;
			::Uml::SetAssocRole(JClass::meta_srcJInheritance,JClass::meta,::JavaModel::JClass::meta, "dstJInheritance");
			::JavaModel::JClass::meta_dstJInheritance_rev = JClass::meta_srcJInheritance;
			::Uml::SetAssocRole(JClass::meta_srcJAgregation,JClass::meta,::JavaModel::JClass::meta, "dstJAgregation");
			::JavaModel::JClass::meta_dstJAgregation_rev = JClass::meta_srcJAgregation;
			JClassHasJFeature::meta_srcJClassHasJFeature_end_ = ::JavaModel::JFeature::meta_srcJClassHasJFeature;
			JClassHasJFeature::meta_dstJClassHasJFeature_end_ = ::JavaModel::JClass::meta_dstJClassHasJFeature;
			JInheritance::meta_srcJInheritance_end_ = ::JavaModel::JClass::meta_srcJInheritance;
			JInheritance::meta_dstJInheritance_end_ = ::JavaModel::JClass::meta_dstJInheritance;
			JAgregation::meta_srcJAgregation_end_ = ::JavaModel::JClass::meta_srcJAgregation;
			JAgregation::meta_dstJAgregation_end_ = ::JavaModel::JClass::meta_dstJAgregation;

			
		}
	 void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		::Uml::Initialize();

		::MI2SI::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(::Uml::diagram);
		meta_dn->CreateNew("JavaModel.mem", "", ::Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = ::Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="JavaModel";
		umldiagram.version() ="1.00";
		InitializeDgr();


		InitCrossNSInheritence();
		InitCrossNSCompositions();
	};
	 void Initialize(const ::Uml::Diagram &dgr)
	{
		umldiagram = dgr;
		InitializeDgr(dgr);
	};
	 Udm::UdmDiagram diagram = { &umldiagram, Initialize };
	static struct _regClass
	{
		_regClass()
		{
			Udm::MetaDepository::StoreDiagram("JavaModel", diagram);
		};
		~_regClass()
		{
			Udm::MetaDepository::RemoveDiagram("JavaModel");
		};
	} __regUnUsed;

}
// END JavaModel.cpp
