// cpp(meta datanetwork format) source file UMLModel.cpp generated from diagram UMLModel
// generated on Fri Dec 02 10:50:59 2005

#include "UMLModel.h"
#include "UmlExt.h"

#include "UdmStatic.h"

// cross-package metainformation header file
#include "MI2SI.h"

namespace UMLModel {

	::Uml::Diagram umldiagram;

		::Uml::Class RootFolder::meta;
		::Uml::Class MgaObject::meta;
		::Uml::Class UML::meta;
		::Uml::Class Inheritance::meta;
		::Uml::Class Attribute::meta;
		::Uml::Class Agregation::meta;
		::Uml::Class Class::meta;
		::Uml::Class Feature::meta;
		::Uml::Class Operation::meta;
		::Uml::Class ClassHasFeature::meta;
		::Uml::Attribute RootFolder::meta_name;
		::Uml::Attribute MgaObject::meta_name;
		::Uml::Attribute MgaObject::meta_position;
		::Uml::AssociationRole Inheritance::meta_srcInheritance_end_;
		::Uml::AssociationRole Inheritance::meta_dstInheritance_end_;
		::Uml::AssociationRole Agregation::meta_srcAgregation_end_;
		::Uml::AssociationRole Agregation::meta_dstAgregation_end_;
		::Uml::AssociationRole Class::meta_dstInheritance, Class::meta_dstInheritance_rev;
		::Uml::AssociationRole Class::meta_srcInheritance, Class::meta_srcInheritance_rev;
		::Uml::AssociationRole Class::meta_dstAgregation, Class::meta_dstAgregation_rev;
		::Uml::AssociationRole Class::meta_srcAgregation, Class::meta_srcAgregation_rev;
		::Uml::AssociationRole Class::meta_dstClassHasFeature, Class::meta_dstClassHasFeature_rev;
		::Uml::AssociationRole Class::meta_dst;
		::Uml::AssociationRole Feature::meta_srcClassHasFeature, Feature::meta_srcClassHasFeature_rev;
		::Uml::AssociationRole ClassHasFeature::meta_srcClassHasFeature_end_;
		::Uml::AssociationRole ClassHasFeature::meta_dstClassHasFeature_end_;
		::Uml::CompositionParentRole RootFolder::meta_RootFolder_parent;
		::Uml::CompositionParentRole UML::meta_RootFolder_parent;
		::Uml::CompositionParentRole Inheritance::meta_UML_parent;
		::Uml::CompositionParentRole Agregation::meta_UML_parent;
		::Uml::CompositionParentRole Class::meta_UML_parent;
		::Uml::CompositionParentRole Feature::meta_UML_parent;
		::Uml::CompositionParentRole ClassHasFeature::meta_UML_parent;
		::Uml::CompositionChildRole RootFolder::meta_UML_children;
		::Uml::CompositionChildRole RootFolder::meta_RootFolder_children;
		::Uml::CompositionChildRole UML::meta_Class_children;
		::Uml::CompositionChildRole UML::meta_Agregation_children;
		::Uml::CompositionChildRole UML::meta_Inheritance_children;
		::Uml::CompositionChildRole UML::meta_ClassHasFeature_children;
		::Uml::CompositionChildRole UML::meta_Feature_children;
		void Creates()
		{
			RootFolder::meta = ::Uml::Class::Create(umldiagram);
			MgaObject::meta = ::Uml::Class::Create(umldiagram);
			UML::meta = ::Uml::Class::Create(umldiagram);
			Inheritance::meta = ::Uml::Class::Create(umldiagram);
			Attribute::meta = ::Uml::Class::Create(umldiagram);
			Agregation::meta = ::Uml::Class::Create(umldiagram);
			Class::meta = ::Uml::Class::Create(umldiagram);
			Feature::meta = ::Uml::Class::Create(umldiagram);
			Operation::meta = ::Uml::Class::Create(umldiagram);
			ClassHasFeature::meta = ::Uml::Class::Create(umldiagram);
			RootFolder::meta_name = ::Uml::Attribute::Create(RootFolder::meta);
			MgaObject::meta_name = ::Uml::Attribute::Create(MgaObject::meta);
			MgaObject::meta_position = ::Uml::Attribute::Create(MgaObject::meta);
		}
		void InitClassesAttributes()
		{
			RootFolder::meta.name() = "RootFolder";
			RootFolder::meta.isAbstract() = false;
			RootFolder::meta.stereotype() = "Folder";
			MgaObject::meta.name() = "MgaObject";
			MgaObject::meta.isAbstract() = true;
			UML::meta.name() = "UML";
			UML::meta.isAbstract() = false;
			UML::meta.stereotype() = "Model";
			Inheritance::meta.name() = "Inheritance";
			Inheritance::meta.isAbstract() = false;
			Inheritance::meta.stereotype() = "Connection";
			Attribute::meta.name() = "Attribute";
			Attribute::meta.isAbstract() = false;
			Attribute::meta.stereotype() = "Atom";
			Agregation::meta.name() = "Agregation";
			Agregation::meta.isAbstract() = false;
			Agregation::meta.stereotype() = "Connection";
			Class::meta.name() = "Class";
			Class::meta.isAbstract() = false;
			Class::meta.stereotype() = "Atom";
			Feature::meta.name() = "Feature";
			Feature::meta.isAbstract() = false;
			Feature::meta.stereotype() = "Atom";
			Operation::meta.name() = "Operation";
			Operation::meta.isAbstract() = false;
			Operation::meta.stereotype() = "Atom";
			ClassHasFeature::meta.name() = "ClassHasFeature";
			ClassHasFeature::meta.isAbstract() = false;
			ClassHasFeature::meta.stereotype() = "Connection";
			
			RootFolder::meta_name.name() = "name";
			RootFolder::meta_name.type() = "String";
			RootFolder::meta_name.min() = 0;
			RootFolder::meta_name.max() = 1;
			RootFolder::meta_name.nonpersistent() = false;
			RootFolder::meta_name.registry() = false;
			RootFolder::meta_name.ordered() = false;
			RootFolder::meta_name.visibility() = "public";
			RootFolder::meta_name.defvalue() = vector<string>();
			MgaObject::meta_name.name() = "name";
			MgaObject::meta_name.type() = "String";
			MgaObject::meta_name.min() = 0;
			MgaObject::meta_name.max() = 1;
			MgaObject::meta_name.nonpersistent() = false;
			MgaObject::meta_name.registry() = false;
			MgaObject::meta_name.ordered() = false;
			MgaObject::meta_name.visibility() = "public";
			MgaObject::meta_name.defvalue() = vector<string>();
			MgaObject::meta_position.name() = "position";
			MgaObject::meta_position.type() = "String";
			MgaObject::meta_position.min() = 0;
			MgaObject::meta_position.max() = 1;
			MgaObject::meta_position.nonpersistent() = false;
			MgaObject::meta_position.registry() = false;
			MgaObject::meta_position.ordered() = false;
			MgaObject::meta_position.visibility() = "public";
			MgaObject::meta_position.defvalue() = vector<string>();
			
		}
		void InitAssociation0()
		{
			::Uml::Association ass = ::Uml::Association::Create(umldiagram);
			ass.name() = "Inheritance";
			ass.assocClass() = ::UMLModel::Inheritance::meta;
			::UMLModel::Class::meta_dstInheritance = ::Uml::AssociationRole::Create(ass);
			::UMLModel::Class::meta_dstInheritance.name() = "dstInheritance";
			::UMLModel::Class::meta_dstInheritance.min() = 0;
			::UMLModel::Class::meta_dstInheritance.max() = -1;
			::UMLModel::Class::meta_dstInheritance.isNavigable() = true;
			::UMLModel::Class::meta_dstInheritance.isPrimary() = false;
			::UMLModel::Class::meta_dstInheritance.target() = ::UMLModel::Class::meta;
			::UMLModel::Inheritance::meta_dstInheritance_end_ = ::UMLModel::Class::meta_srcInheritance_rev = ::UMLModel::Class::meta_dstInheritance;
			::UMLModel::Class::meta_srcInheritance = ::Uml::AssociationRole::Create(ass);
			::UMLModel::Class::meta_srcInheritance.name() = "srcInheritance";
			::UMLModel::Class::meta_srcInheritance.min() = 0;
			::UMLModel::Class::meta_srcInheritance.max() = -1;
			::UMLModel::Class::meta_srcInheritance.isNavigable() = true;
			::UMLModel::Class::meta_srcInheritance.isPrimary() = false;
			::UMLModel::Class::meta_srcInheritance.target() = ::UMLModel::Class::meta;
			::UMLModel::Inheritance::meta_srcInheritance_end_ = ::UMLModel::Class::meta_dstInheritance_rev = ::UMLModel::Class::meta_srcInheritance;
		};
		void InitAssociation1()
		{
			::Uml::Association ass = ::Uml::Association::Create(umldiagram);
			ass.name() = "Agregation";
			ass.assocClass() = ::UMLModel::Agregation::meta;
			::UMLModel::Class::meta_dstAgregation = ::Uml::AssociationRole::Create(ass);
			::UMLModel::Class::meta_dstAgregation.name() = "dstAgregation";
			::UMLModel::Class::meta_dstAgregation.min() = 0;
			::UMLModel::Class::meta_dstAgregation.max() = -1;
			::UMLModel::Class::meta_dstAgregation.isNavigable() = true;
			::UMLModel::Class::meta_dstAgregation.isPrimary() = false;
			::UMLModel::Class::meta_dstAgregation.target() = ::UMLModel::Class::meta;
			::UMLModel::Agregation::meta_dstAgregation_end_ = ::UMLModel::Class::meta_srcAgregation_rev = ::UMLModel::Class::meta_dstAgregation;
			::UMLModel::Class::meta_srcAgregation = ::Uml::AssociationRole::Create(ass);
			::UMLModel::Class::meta_srcAgregation.name() = "srcAgregation";
			::UMLModel::Class::meta_srcAgregation.min() = 0;
			::UMLModel::Class::meta_srcAgregation.max() = -1;
			::UMLModel::Class::meta_srcAgregation.isNavigable() = true;
			::UMLModel::Class::meta_srcAgregation.isPrimary() = false;
			::UMLModel::Class::meta_srcAgregation.target() = ::UMLModel::Class::meta;
			::UMLModel::Agregation::meta_srcAgregation_end_ = ::UMLModel::Class::meta_dstAgregation_rev = ::UMLModel::Class::meta_srcAgregation;
		};
		void InitAssociation2()
		{
			::Uml::Association ass = ::Uml::Association::Create(umldiagram);
			ass.name() = "ClassHasFeature";
			ass.assocClass() = ::UMLModel::ClassHasFeature::meta;
			::UMLModel::Class::meta_dstClassHasFeature = ::Uml::AssociationRole::Create(ass);
			::UMLModel::Class::meta_dstClassHasFeature.name() = "dstClassHasFeature";
			::UMLModel::Class::meta_dstClassHasFeature.min() = 0;
			::UMLModel::Class::meta_dstClassHasFeature.max() = -1;
			::UMLModel::Class::meta_dstClassHasFeature.isNavigable() = true;
			::UMLModel::Class::meta_dstClassHasFeature.isPrimary() = false;
			::UMLModel::Class::meta_dstClassHasFeature.target() = ::UMLModel::Feature::meta;
			::UMLModel::ClassHasFeature::meta_dstClassHasFeature_end_ = ::UMLModel::Feature::meta_srcClassHasFeature_rev = ::UMLModel::Class::meta_dstClassHasFeature;
			::UMLModel::Feature::meta_srcClassHasFeature = ::Uml::AssociationRole::Create(ass);
			::UMLModel::Feature::meta_srcClassHasFeature.name() = "srcClassHasFeature";
			::UMLModel::Feature::meta_srcClassHasFeature.min() = 1;
			::UMLModel::Feature::meta_srcClassHasFeature.max() = 1;
			::UMLModel::Feature::meta_srcClassHasFeature.isNavigable() = true;
			::UMLModel::Feature::meta_srcClassHasFeature.isPrimary() = false;
			::UMLModel::Feature::meta_srcClassHasFeature.target() = ::UMLModel::Class::meta;
			::UMLModel::ClassHasFeature::meta_srcClassHasFeature_end_ = ::UMLModel::Class::meta_dstClassHasFeature_rev = ::UMLModel::Feature::meta_srcClassHasFeature;
		};
		void InitComposition0()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::UMLModel::UML::meta_RootFolder_parent = ::Uml::CompositionParentRole::Create(comp);
			::UMLModel::UML::meta_RootFolder_parent.name() = "RootFolder_parent";
			::UMLModel::UML::meta_RootFolder_parent.isNavigable() = true;
			::UMLModel::UML::meta_RootFolder_parent.target() = ::UMLModel::RootFolder::meta;
			::UMLModel::RootFolder::meta_UML_children = ::Uml::CompositionChildRole::Create(comp);
			::UMLModel::RootFolder::meta_UML_children.name() = "UML";
			::UMLModel::RootFolder::meta_UML_children.min() = 0;
			::UMLModel::RootFolder::meta_UML_children.max() = -1;
			::UMLModel::RootFolder::meta_UML_children.isNavigable() = true;
			::UMLModel::RootFolder::meta_UML_children.target() = ::UMLModel::UML::meta;
		}
		void InitComposition1()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::UMLModel::RootFolder::meta_RootFolder_parent = ::Uml::CompositionParentRole::Create(comp);
			::UMLModel::RootFolder::meta_RootFolder_parent.name() = "RootFolder_parent";
			::UMLModel::RootFolder::meta_RootFolder_parent.isNavigable() = true;
			::UMLModel::RootFolder::meta_RootFolder_parent.target() = ::UMLModel::RootFolder::meta;
			::UMLModel::RootFolder::meta_RootFolder_children = ::Uml::CompositionChildRole::Create(comp);
			::UMLModel::RootFolder::meta_RootFolder_children.name() = "RootFolder";
			::UMLModel::RootFolder::meta_RootFolder_children.min() = 0;
			::UMLModel::RootFolder::meta_RootFolder_children.max() = -1;
			::UMLModel::RootFolder::meta_RootFolder_children.isNavigable() = true;
			::UMLModel::RootFolder::meta_RootFolder_children.target() = ::UMLModel::RootFolder::meta;
		}
		void InitComposition2()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::UMLModel::Class::meta_UML_parent = ::Uml::CompositionParentRole::Create(comp);
			::UMLModel::Class::meta_UML_parent.name() = "UML_parent";
			::UMLModel::Class::meta_UML_parent.isNavigable() = true;
			::UMLModel::Class::meta_UML_parent.target() = ::UMLModel::UML::meta;
			::UMLModel::UML::meta_Class_children = ::Uml::CompositionChildRole::Create(comp);
			::UMLModel::UML::meta_Class_children.name() = "Class";
			::UMLModel::UML::meta_Class_children.min() = 0;
			::UMLModel::UML::meta_Class_children.max() = -1;
			::UMLModel::UML::meta_Class_children.isNavigable() = true;
			::UMLModel::UML::meta_Class_children.target() = ::UMLModel::Class::meta;
		}
		void InitComposition3()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::UMLModel::Agregation::meta_UML_parent = ::Uml::CompositionParentRole::Create(comp);
			::UMLModel::Agregation::meta_UML_parent.name() = "UML_parent";
			::UMLModel::Agregation::meta_UML_parent.isNavigable() = true;
			::UMLModel::Agregation::meta_UML_parent.target() = ::UMLModel::UML::meta;
			::UMLModel::UML::meta_Agregation_children = ::Uml::CompositionChildRole::Create(comp);
			::UMLModel::UML::meta_Agregation_children.name() = "Agregation";
			::UMLModel::UML::meta_Agregation_children.min() = 0;
			::UMLModel::UML::meta_Agregation_children.max() = -1;
			::UMLModel::UML::meta_Agregation_children.isNavigable() = true;
			::UMLModel::UML::meta_Agregation_children.target() = ::UMLModel::Agregation::meta;
		}
		void InitComposition4()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::UMLModel::Inheritance::meta_UML_parent = ::Uml::CompositionParentRole::Create(comp);
			::UMLModel::Inheritance::meta_UML_parent.name() = "UML_parent";
			::UMLModel::Inheritance::meta_UML_parent.isNavigable() = true;
			::UMLModel::Inheritance::meta_UML_parent.target() = ::UMLModel::UML::meta;
			::UMLModel::UML::meta_Inheritance_children = ::Uml::CompositionChildRole::Create(comp);
			::UMLModel::UML::meta_Inheritance_children.name() = "Inheritance";
			::UMLModel::UML::meta_Inheritance_children.min() = 0;
			::UMLModel::UML::meta_Inheritance_children.max() = -1;
			::UMLModel::UML::meta_Inheritance_children.isNavigable() = true;
			::UMLModel::UML::meta_Inheritance_children.target() = ::UMLModel::Inheritance::meta;
		}
		void InitComposition5()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::UMLModel::ClassHasFeature::meta_UML_parent = ::Uml::CompositionParentRole::Create(comp);
			::UMLModel::ClassHasFeature::meta_UML_parent.name() = "UML_parent";
			::UMLModel::ClassHasFeature::meta_UML_parent.isNavigable() = true;
			::UMLModel::ClassHasFeature::meta_UML_parent.target() = ::UMLModel::UML::meta;
			::UMLModel::UML::meta_ClassHasFeature_children = ::Uml::CompositionChildRole::Create(comp);
			::UMLModel::UML::meta_ClassHasFeature_children.name() = "ClassHasFeature";
			::UMLModel::UML::meta_ClassHasFeature_children.min() = 0;
			::UMLModel::UML::meta_ClassHasFeature_children.max() = -1;
			::UMLModel::UML::meta_ClassHasFeature_children.isNavigable() = true;
			::UMLModel::UML::meta_ClassHasFeature_children.target() = ::UMLModel::ClassHasFeature::meta;
		}
		void InitComposition6()
		{
			::Uml::Composition comp = ::Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
			::UMLModel::Feature::meta_UML_parent = ::Uml::CompositionParentRole::Create(comp);
			::UMLModel::Feature::meta_UML_parent.name() = "UML_parent";
			::UMLModel::Feature::meta_UML_parent.isNavigable() = true;
			::UMLModel::Feature::meta_UML_parent.target() = ::UMLModel::UML::meta;
			::UMLModel::UML::meta_Feature_children = ::Uml::CompositionChildRole::Create(comp);
			::UMLModel::UML::meta_Feature_children.name() = "Feature";
			::UMLModel::UML::meta_Feature_children.min() = 0;
			::UMLModel::UML::meta_Feature_children.max() = -1;
			::UMLModel::UML::meta_Feature_children.isNavigable() = true;
			::UMLModel::UML::meta_Feature_children.target() = ::UMLModel::Feature::meta;
		}
		void InitCrossNSCompositions()
		{
		}
		void InitInheritence()
		{
			MgaObject::meta.subTypes() +=  ::UMLModel::UML::meta;
			MgaObject::meta.subTypes() +=  ::UMLModel::Inheritance::meta;
			MgaObject::meta.subTypes() +=  ::UMLModel::Attribute::meta;
			MgaObject::meta.subTypes() +=  ::UMLModel::Agregation::meta;
			MgaObject::meta.subTypes() +=  ::UMLModel::Class::meta;
			MgaObject::meta.subTypes() +=  ::UMLModel::ClassHasFeature::meta;
			Attribute::meta.subTypes() +=  ::UMLModel::Feature::meta;
			Attribute::meta.subTypes() +=  ::UMLModel::Operation::meta;
		}
		void InitCrossNSInheritence()
		{
		}
	 void InitializeDgr()
	{
		Creates();
		InitClassesAttributes();
			InitAssociation0();
			InitAssociation1();
			InitAssociation2();
		InitComposition0();
		InitComposition1();
		InitComposition2();
		InitComposition3();
		InitComposition4();
		InitComposition5();
		InitComposition6();
			Class::meta_dst = ::MI2SI::Class_cross_ph_::meta_dst;
		InitInheritence();
		
	}
		 void InitializeDgr(const ::Uml::Diagram & dgr)
		{
			::Uml::SetClass(RootFolder::meta, dgr, "RootFolder");
			::Uml::SetAttribute(RootFolder::meta_name,RootFolder::meta, "name");
			::Uml::SetClass(MgaObject::meta, dgr, "MgaObject");
			::Uml::SetAttribute(MgaObject::meta_name,MgaObject::meta, "name");
			::Uml::SetAttribute(MgaObject::meta_position,MgaObject::meta, "position");
			::Uml::SetClass(UML::meta, dgr, "UML");
			::Uml::SetClass(Inheritance::meta, dgr, "Inheritance");
			::Uml::SetClass(Attribute::meta, dgr, "Attribute");
			::Uml::SetClass(Agregation::meta, dgr, "Agregation");
			::Uml::SetClass(Class::meta, dgr, "Class");
			::Uml::SetClass(Feature::meta, dgr, "Feature");
			::Uml::SetClass(Operation::meta, dgr, "Operation");
			::Uml::SetClass(ClassHasFeature::meta, dgr, "ClassHasFeature");
			//composition child roles 
			::Uml::SetParentRole(RootFolder::meta_RootFolder_parent,RootFolder::meta,::UMLModel::RootFolder::meta, "", "");
			::Uml::SetParentRole(UML::meta_RootFolder_parent,UML::meta,::UMLModel::RootFolder::meta, "", "");
			::Uml::SetParentRole(Inheritance::meta_UML_parent,Inheritance::meta,::UMLModel::UML::meta, "", "");
			::Uml::SetParentRole(Agregation::meta_UML_parent,Agregation::meta,::UMLModel::UML::meta, "", "");
			::Uml::SetParentRole(Class::meta_UML_parent,Class::meta,::UMLModel::UML::meta, "", "");
			::Uml::SetParentRole(Feature::meta_UML_parent,Feature::meta,::UMLModel::UML::meta, "", "");
			::Uml::SetParentRole(ClassHasFeature::meta_UML_parent,ClassHasFeature::meta,::UMLModel::UML::meta, "", "");
			// composition parentroles 
			::Uml::SetChildRole(RootFolder::meta_UML_children,RootFolder::meta,::UMLModel::UML::meta, "", "");
			::Uml::SetChildRole(RootFolder::meta_RootFolder_children,RootFolder::meta,::UMLModel::RootFolder::meta, "", "");
			::Uml::SetChildRole(UML::meta_Class_children,UML::meta,::UMLModel::Class::meta, "", "");
			::Uml::SetChildRole(UML::meta_Agregation_children,UML::meta,::UMLModel::Agregation::meta, "", "");
			::Uml::SetChildRole(UML::meta_Inheritance_children,UML::meta,::UMLModel::Inheritance::meta, "", "");
			::Uml::SetChildRole(UML::meta_ClassHasFeature_children,UML::meta,::UMLModel::ClassHasFeature::meta, "", "");
			::Uml::SetChildRole(UML::meta_Feature_children,UML::meta,::UMLModel::Feature::meta, "", "");
			// Association roles 
			::Uml::SetAssocRole(Class::meta_dstInheritance,Class::meta,::UMLModel::Class::meta, "srcInheritance");
			::UMLModel::Class::meta_srcInheritance_rev = Class::meta_dstInheritance;
			::Uml::SetAssocRole(Class::meta_srcInheritance,Class::meta,::UMLModel::Class::meta, "dstInheritance");
			::UMLModel::Class::meta_dstInheritance_rev = Class::meta_srcInheritance;
			::Uml::SetAssocRole(Class::meta_dstAgregation,Class::meta,::UMLModel::Class::meta, "srcAgregation");
			::UMLModel::Class::meta_srcAgregation_rev = Class::meta_dstAgregation;
			::Uml::SetAssocRole(Class::meta_srcAgregation,Class::meta,::UMLModel::Class::meta, "dstAgregation");
			::UMLModel::Class::meta_dstAgregation_rev = Class::meta_srcAgregation;
			::Uml::SetAssocRole(Class::meta_dstClassHasFeature,Class::meta,::UMLModel::Feature::meta, "srcClassHasFeature");
			::UMLModel::Feature::meta_srcClassHasFeature_rev = Class::meta_dstClassHasFeature;
			::Uml::SetAssocRole(Feature::meta_srcClassHasFeature,Feature::meta,::UMLModel::Class::meta, "dstClassHasFeature");
			::UMLModel::Class::meta_dstClassHasFeature_rev = Feature::meta_srcClassHasFeature;
			Inheritance::meta_srcInheritance_end_ = ::UMLModel::Class::meta_srcInheritance;
			Inheritance::meta_dstInheritance_end_ = ::UMLModel::Class::meta_dstInheritance;
			Agregation::meta_srcAgregation_end_ = ::UMLModel::Class::meta_srcAgregation;
			Agregation::meta_dstAgregation_end_ = ::UMLModel::Class::meta_dstAgregation;
			ClassHasFeature::meta_srcClassHasFeature_end_ = ::UMLModel::Feature::meta_srcClassHasFeature;
			ClassHasFeature::meta_dstClassHasFeature_end_ = ::UMLModel::Class::meta_dstClassHasFeature;

			
		}
	 void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		::Uml::Initialize();

		::MI2SI::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(::Uml::diagram);
		meta_dn->CreateNew("UMLModel.mem", "", ::Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = ::Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="UMLModel";
		umldiagram.version() ="1.00";
		InitializeDgr();


		InitCrossNSInheritence();
		InitCrossNSCompositions();
	};
	 void Initialize(const ::Uml::Diagram &dgr)
	{
		umldiagram = dgr;
		InitializeDgr(dgr);
	};
	 Udm::UdmDiagram diagram = { &umldiagram, Initialize };
	static struct _regClass
	{
		_regClass()
		{
			Udm::MetaDepository::StoreDiagram("UMLModel", diagram);
		};
		~_regClass()
		{
			Udm::MetaDepository::RemoveDiagram("UMLModel");
		};
	} __regUnUsed;

}
// END UMLModel.cpp
